/* CertButton.c generated by valac 0.39.7, the Vala compiler
 * generated from CertButton.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (http://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gcr/gcr-base.h>
#include <ui/gcr-ui.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_CERT_BUTTON (cert_button_get_type ())
#define CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CERT_BUTTON, CertButton))
#define CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CERT_BUTTON, CertButtonClass))
#define IS_CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CERT_BUTTON))
#define IS_CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CERT_BUTTON))
#define CERT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CERT_BUTTON, CertButtonClass))

typedef struct _CertButton CertButton;
typedef struct _CertButtonClass CertButtonClass;
typedef struct _CertButtonPrivate CertButtonPrivate;

#define CERT_BUTTON_TYPE_SECURITY (cert_button_security_get_type ())

#define TYPE_CAPTIVE_LOGIN (captive_login_get_type ())
#define CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLogin))
#define CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))
#define IS_CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAPTIVE_LOGIN))
#define IS_CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAPTIVE_LOGIN))
#define CAPTIVE_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))

typedef struct _CaptiveLogin CaptiveLogin;
typedef struct _CaptiveLoginClass CaptiveLoginClass;
enum  {
	CERT_BUTTON_0_PROPERTY,
	CERT_BUTTON_SECURITY_PROPERTY,
	CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY,
	CERT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* cert_button_properties[CERT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))

struct _CertButton {
	GtkToggleButton parent_instance;
	CertButtonPrivate * priv;
};

struct _CertButtonClass {
	GtkToggleButtonClass parent_class;
};

typedef enum  {
	CERT_BUTTON_SECURITY_NONE,
	CERT_BUTTON_SECURITY_SECURE,
	CERT_BUTTON_SECURITY_LOADING,
	CERT_BUTTON_SECURITY_MIXED_CONTENT
} CertButtonSecurity;

struct _CertButtonPrivate {
	CertButtonSecurity _security;
	CaptiveLogin* _captive_login_window;
};

struct _Block2Data {
	int _ref_count_;
	CertButton* self;
	GtkPopover* popover;
};


static gpointer cert_button_parent_class = NULL;

GType cert_button_get_type (void) G_GNUC_CONST;
GType cert_button_security_get_type (void) G_GNUC_CONST;
GType captive_login_get_type (void) G_GNUC_CONST;
#define CERT_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CERT_BUTTON, CertButtonPrivate))
CertButton* cert_button_new (CaptiveLogin* captive_login_window);
CertButton* cert_button_construct (GType object_type,
                                   CaptiveLogin* captive_login_window);
static void cert_button_on_tls_button_click (CertButton* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
CaptiveLogin* cert_button_get_captive_login_window (CertButton* self);
gboolean captive_login_get_tls_info (CaptiveLogin* self,
                                     GTlsCertificate* * certificate,
                                     GTlsCertificateFlags* errors);
gchar* captive_login_get_uri (CaptiveLogin* self);
CertButtonSecurity cert_button_get_security (CertButton* self);
static gboolean __lambda7_ (CertButton* self,
                     GdkEventButton* event);
static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self);
static gboolean __lambda8_ (Block2Data* _data2_,
                     GdkEventButton* event);
static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
void cert_button_set_security (CertButton* self,
                               CertButtonSecurity value);
void cert_button_set_captive_login_window (CertButton* self,
                                           CaptiveLogin* value);
static GObject * cert_button_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                 gpointer self);
static void cert_button_finalize (GObject * obj);
static void _vala_cert_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_cert_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GType
cert_button_security_get_type (void)
{
	static volatile gsize cert_button_security_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_security_type_id__volatile)) {
		static const GEnumValue values[] = {{CERT_BUTTON_SECURITY_NONE, "CERT_BUTTON_SECURITY_NONE", "none"}, {CERT_BUTTON_SECURITY_SECURE, "CERT_BUTTON_SECURITY_SECURE", "secure"}, {CERT_BUTTON_SECURITY_LOADING, "CERT_BUTTON_SECURITY_LOADING", "loading"}, {CERT_BUTTON_SECURITY_MIXED_CONTENT, "CERT_BUTTON_SECURITY_MIXED_CONTENT", "mixed-content"}, {0, NULL, NULL}};
		GType cert_button_security_type_id;
		cert_button_security_type_id = g_enum_register_static ("CertButtonSecurity", values);
		g_once_init_leave (&cert_button_security_type_id__volatile, cert_button_security_type_id);
	}
	return cert_button_security_type_id__volatile;
}


CertButton*
cert_button_construct (GType object_type,
                       CaptiveLogin* captive_login_window)
{
	CertButton * self = NULL;
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (captive_login_window != NULL, NULL);
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = (CertButton*) g_object_new (object_type, "security", CERT_BUTTON_SECURITY_LOADING, "captive-login-window", captive_login_window, NULL);
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return self;
#line 181 "CertButton.c"
}


CertButton*
cert_button_new (CaptiveLogin* captive_login_window)
{
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return cert_button_construct (TYPE_CERT_BUTTON, captive_login_window);
#line 190 "CertButton.c"
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return _data2_;
#line 201 "CertButton.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 212 "CertButton.c"
		CertButton* self;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		self = _data2_->self;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (_data2_->popover);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (self);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_slice_free (Block2Data, _data2_);
#line 222 "CertButton.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 232 "CertButton.c"
}


static gboolean
__lambda7_ (CertButton* self,
            GdkEventButton* event)
{
	gboolean result = FALSE;
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 152 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = TRUE;
#line 152 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 247 "CertButton.c"
}


static gboolean
___lambda7__gtk_widget_button_press_event (GtkWidget* _sender,
                                           GdkEventButton* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda7_ ((CertButton*) self, event);
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 260 "CertButton.c"
}


static gboolean
__lambda8_ (Block2Data* _data2_,
            GdkEventButton* event)
{
	CertButton* self;
	gboolean result = FALSE;
	GtkWidget* child = NULL;
	GtkPopover* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* event_widget = NULL;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkWidget* _tmp6_;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = _data2_->self;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = _data2_->popover;
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	child = _tmp2_;
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp3_ = gtk_get_event_widget ((GdkEvent*) event);
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	event_widget = _tmp4_;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp6_ = child;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp6_ != NULL) {
#line 301 "CertButton.c"
		GdkWindow* _tmp7_;
		GtkPopover* _tmp8_;
		GdkWindow* _tmp9_;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp7_ = event->window;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp8_ = _data2_->popover;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp9_ = gtk_widget_get_window ((GtkWidget*) _tmp8_);
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp5_ = _tmp7_ == _tmp9_;
#line 313 "CertButton.c"
	} else {
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp5_ = FALSE;
#line 317 "CertButton.c"
	}
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp5_) {
#line 321 "CertButton.c"
		GtkAllocation child_alloc = {0};
		GtkPopover* _tmp10_;
		GtkAllocation _tmp11_ = {0};
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gdouble _tmp15_;
		GtkAllocation _tmp16_;
		gint _tmp17_;
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp10_ = _data2_->popover;
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_widget_get_allocation ((GtkWidget*) _tmp10_, &_tmp11_);
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		child_alloc = _tmp11_;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp15_ = event->x;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp16_ = child_alloc;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp17_ = _tmp16_.x;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp15_ < ((gdouble) _tmp17_)) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp14_ = TRUE;
#line 347 "CertButton.c"
		} else {
			gdouble _tmp18_;
			GtkAllocation _tmp19_;
			gint _tmp20_;
			GtkAllocation _tmp21_;
			gint _tmp22_;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp18_ = event->x;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp19_ = child_alloc;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp20_ = _tmp19_.x;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp21_ = child_alloc;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp22_ = _tmp21_.width;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp14_ = _tmp18_ > ((gdouble) (_tmp20_ + _tmp22_));
#line 366 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp14_) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp13_ = TRUE;
#line 372 "CertButton.c"
		} else {
			gdouble _tmp23_;
			GtkAllocation _tmp24_;
			gint _tmp25_;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp23_ = event->y;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp24_ = child_alloc;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp25_ = _tmp24_.y;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp13_ = _tmp23_ < ((gdouble) _tmp25_);
#line 385 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp13_) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp12_ = TRUE;
#line 391 "CertButton.c"
		} else {
			gdouble _tmp26_;
			GtkAllocation _tmp27_;
			gint _tmp28_;
			GtkAllocation _tmp29_;
			gint _tmp30_;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp26_ = event->y;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp27_ = child_alloc;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp28_ = _tmp27_.y;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp29_ = child_alloc;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp30_ = _tmp29_.height;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp12_ = _tmp26_ > ((gdouble) (_tmp28_ + _tmp30_));
#line 410 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp12_) {
#line 414 "CertButton.c"
			GtkPopover* _tmp31_;
#line 167 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp31_ = _data2_->popover;
#line 167 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp31_);
#line 168 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 422 "CertButton.c"
		}
	} else {
		gboolean _tmp32_ = FALSE;
		GtkWidget* _tmp33_;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp33_ = event_widget;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp33_ != NULL) {
#line 431 "CertButton.c"
			GtkWidget* _tmp34_;
			GtkPopover* _tmp35_;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp34_ = event_widget;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp35_ = _data2_->popover;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp32_ = !gtk_widget_is_ancestor (_tmp34_, (GtkWidget*) _tmp35_);
#line 440 "CertButton.c"
		} else {
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp32_ = FALSE;
#line 444 "CertButton.c"
		}
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp32_) {
#line 448 "CertButton.c"
			GtkPopover* _tmp36_;
#line 171 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp36_ = _data2_->popover;
#line 171 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp36_);
#line 172 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 456 "CertButton.c"
		}
	}
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = TRUE;
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (event_widget);
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (child);
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 467 "CertButton.c"
}


static gboolean
___lambda8__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda8_ (self, event);
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 480 "CertButton.c"
}


static void
cert_button_on_tls_button_click (CertButton* self)
{
	Block2Data* _data2_;
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0;
	CaptiveLogin* _tmp0_;
	GTlsCertificate* _tmp1_ = NULL;
	GTlsCertificateFlags _tmp2_ = 0;
	gboolean _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
	GIcon* button_icon = NULL;
	GtkWidget* _tmp6_;
	GIcon* _tmp7_ = NULL;
	GIcon* _tmp8_;
	GtkImage* icon = NULL;
	GIcon* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkLabel* primary_text = NULL;
	CaptiveLogin* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* secondary_text = NULL;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	CertButtonSecurity _tmp27_;
	CertButtonSecurity _tmp28_;
	GcrSimpleCertificate* gcr_cert = NULL;
	GTlsCertificate* _tmp37_;
	GByteArray* _tmp38_;
	GByteArray* _tmp39_;
	GByteArray* _tmp40_;
	guint8* _tmp41_;
	gint _tmp41__length1;
	GcrSimpleCertificate* _tmp42_;
	GcrSimpleCertificate* _tmp43_;
	GcrCertificateWidget* cert_details = NULL;
	GcrSimpleCertificate* _tmp44_;
	GcrCertificateWidget* _tmp45_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkImage* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	GtkGrid* _tmp52_;
	GtkLabel* _tmp53_;
	GtkGrid* _tmp54_;
	GcrCertificateWidget* _tmp55_;
	GtkPopover* _tmp56_;
	GtkGrid* _tmp57_;
	GtkPopover* _tmp58_;
	GtkPopover* _tmp59_;
	GtkPopover* _tmp60_;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->_ref_count_ = 1;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->self = g_object_ref (self);
#line 92 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) self)) {
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (cert);
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		block2_data_unref (_data2_);
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_data2_ = NULL;
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		return;
#line 569 "CertButton.c"
	}
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = self->priv->_captive_login_window;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp3_ = captive_login_get_tls_info (_tmp0_, &_tmp1_, &_tmp2_);
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert);
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert = _tmp1_;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_flags = _tmp2_;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (!_tmp3_) {
#line 97 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (cert);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		block2_data_unref (_data2_);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_data2_ = NULL;
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		return;
#line 593 "CertButton.c"
	}
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp4_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp4_);
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->popover = _tmp4_;
#line 102 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp5_ = _data2_->popover;
#line 102 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp5_, (guint) 12);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp6_ = gtk_button_get_image ((GtkButton*) self);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_image_get_gicon (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_image_get_type (), GtkImage), &_tmp7_, (GtkIconSize*) NULL);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	button_icon = _tmp8_;
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp9_ = button_icon;
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_gicon (_tmp9_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp10_);
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	icon = _tmp10_;
#line 117 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp11_ = icon;
#line 117 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp12_ = self->priv->_captive_login_window;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp13_ = captive_login_get_uri (_tmp12_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp14_ = _tmp13_;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_tmp14_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp15_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp16_ = _tmp15_;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_free0 (_tmp14_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	primary_text = _tmp16_;
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp17_ = primary_text;
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp18_, "h3");
#line 121 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp19_ = primary_text;
#line 121 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 122 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp20_ = primary_text;
#line 122 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp20_, 9);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp21_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp22_ = _tmp21_;
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (_tmp22_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp23_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp24_ = _tmp23_;
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_free0 (_tmp22_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	secondary_text = _tmp24_;
#line 125 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp25_ = secondary_text;
#line 125 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_START);
#line 126 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp26_ = secondary_text;
#line 126 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp26_, 9);
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp27_ = cert_button_get_security (self);
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp28_ = _tmp27_;
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp28_ == CERT_BUTTON_SECURITY_SECURE) {
#line 685 "CertButton.c"
		GtkImage* _tmp29_;
		GtkStyleContext* _tmp30_;
		GtkLabel* _tmp31_;
		GtkStyleContext* _tmp32_;
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp29_ = icon;
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _tmp29_);
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp30_, "success");
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp31_ = secondary_text;
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp32_ = gtk_widget_get_style_context ((GtkWidget*) _tmp31_);
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp32_, "success");
#line 702 "CertButton.c"
	} else {
		GtkImage* _tmp33_;
		GtkStyleContext* _tmp34_;
		GtkLabel* _tmp35_;
		GtkStyleContext* _tmp36_;
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp33_ = icon;
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp34_ = gtk_widget_get_style_context ((GtkWidget*) _tmp33_);
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp34_, "warning");
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp35_ = secondary_text;
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp36_, "warning");
#line 720 "CertButton.c"
	}
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp37_ = cert;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_get (_tmp37_, "certificate", &_tmp38_, NULL);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp39_ = _tmp38_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp40_ = _tmp39_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp41_ = _tmp40_->data;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp41__length1 = (gint) _tmp40_->len;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp42_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp41_, _tmp41__length1);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp43_ = _tmp42_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_byte_array_unref0 (_tmp40_);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gcr_cert = _tmp43_;
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp44_ = gcr_cert;
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp45_ = gcr_certificate_widget_new ((GcrCertificate*) _tmp44_);
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp45_);
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_details = _tmp45_;
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp46_ = (GtkGrid*) gtk_grid_new ();
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp46_);
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	grid = _tmp46_;
#line 140 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp47_ = grid;
#line 140 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_set_column_spacing (_tmp47_, 3);
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp48_ = grid;
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp49_ = icon;
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 0, 0, 1, 2);
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp50_ = grid;
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp51_ = primary_text;
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 1, 0, 1, 1);
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp52_ = grid;
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp53_ = secondary_text;
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 1, 1, 1, 1);
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp54_ = grid;
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp55_ = cert_details;
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 1, 2, 1, 1);
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp56_ = _data2_->popover;
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp57_ = grid;
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp58_ = _data2_->popover;
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_object ((GtkWidget*) _tmp58_, "button-press-event", (GCallback) ___lambda7__gtk_widget_button_press_event, self, 0);
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp59_ = _data2_->popover;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_data ((GtkWidget*) _tmp59_, "button-release-event", (GCallback) ___lambda8__gtk_widget_button_release_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 178 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp60_ = _data2_->popover;
#line 178 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp60_);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (grid);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert_details);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (gcr_cert);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (secondary_text);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (primary_text);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (icon);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	block2_data_unref (_data2_);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_ = NULL;
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return;
#line 824 "CertButton.c"
}


CertButtonSecurity
cert_button_get_security (CertButton* self)
{
	CertButtonSecurity result;
	CertButtonSecurity _tmp0_;
#line 33 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = self->priv->_security;
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 841 "CertButton.c"
}


void
cert_button_set_security (CertButton* self,
                          CertButtonSecurity value)
{
	GIcon* icon = NULL;
	gchar* tooltip = NULL;
	GIcon* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	const gchar* _tmp23_;
	gboolean _tmp24_ = FALSE;
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self->priv->_security = value;
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	switch (value) {
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_LOADING:
#line 864 "CertButton.c"
		{
			GThemedIcon* _tmp0_;
			gchar* _tmp1_;
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp0_ = (GThemedIcon*) g_themed_icon_new ("content-loading-symbolic");
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_object_unref0 (icon);
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			icon = (GIcon*) _tmp0_;
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp1_ = g_strdup (_ ("Loading captive portal."));
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_free0 (tooltip);
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			tooltip = _tmp1_;
#line 46 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			break;
#line 882 "CertButton.c"
		}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_NONE:
#line 886 "CertButton.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar** _tmp4_;
			gchar** _tmp5_;
			gint _tmp5__length1;
			GThemedIcon* _tmp6_;
			gchar* _tmp7_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp2_ = g_strdup ("channel-insecure-symbolic");
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp3_ = g_strdup ("security-low");
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp4_ = g_new0 (gchar*, 2 + 1);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp4_[0] = _tmp2_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp4_[1] = _tmp3_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp5_ = _tmp4_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp5__length1 = 2;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp6_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp5_, 2);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_object_unref0 (icon);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			icon = (GIcon*) _tmp6_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp7_ = g_strdup (_ ("The page is served over an unprotected connection."));
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_free0 (tooltip);
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			tooltip = _tmp7_;
#line 50 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			break;
#line 925 "CertButton.c"
		}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_SECURE:
#line 929 "CertButton.c"
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			GThemedIcon* _tmp12_;
			gchar* _tmp13_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp8_ = g_strdup ("channel-secure-symbolic");
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp9_ = g_strdup ("security-high");
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp10_[0] = _tmp8_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp10_[1] = _tmp9_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp11_ = _tmp10_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp11__length1 = 2;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp12_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp11_, 2);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_object_unref0 (icon);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			icon = (GIcon*) _tmp12_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp13_ = g_strdup (_ ("The page is served over a protected connection."));
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_free0 (tooltip);
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			tooltip = _tmp13_;
#line 55 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			break;
#line 968 "CertButton.c"
		}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_MIXED_CONTENT:
#line 972 "CertButton.c"
		{
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar** _tmp16_;
			gchar** _tmp17_;
			gint _tmp17__length1;
			GThemedIcon* _tmp18_;
			gchar* _tmp19_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp14_ = g_strdup ("channel-insecure-symbolic");
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp15_ = g_strdup ("security-low");
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp16_ = g_new0 (gchar*, 2 + 1);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp16_[0] = _tmp14_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp16_[1] = _tmp15_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp17_ = _tmp16_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp17__length1 = 2;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp18_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp17_, 2);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_object_unref0 (icon);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			icon = (GIcon*) _tmp18_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp19_ = g_strdup (_ ("Some elements of this page are served over an unprotected connection."));
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_g_free0 (tooltip);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			tooltip = _tmp19_;
#line 60 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			break;
#line 1011 "CertButton.c"
		}
		default:
		{
#line 63 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			g_assert_not_reached ();
#line 1017 "CertButton.c"
		}
	}
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp20_ = icon;
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp21_ = (GtkImage*) gtk_image_new_from_gicon (_tmp20_, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp21_);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp22_ = _tmp21_;
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp22_);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (_tmp22_);
#line 67 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp23_ = tooltip;
#line 67 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp23_);
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (value != CERT_BUTTON_SECURITY_NONE) {
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp24_ = value != CERT_BUTTON_SECURITY_LOADING;
#line 1040 "CertButton.c"
	} else {
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp24_ = FALSE;
#line 1044 "CertButton.c"
	}
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp24_);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_free0 (tooltip);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (icon);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY]);
#line 1054 "CertButton.c"
}


CaptiveLogin*
cert_button_get_captive_login_window (CertButton* self)
{
	CaptiveLogin* result;
	CaptiveLogin* _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = self->priv->_captive_login_window;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 1071 "CertButton.c"
}


void
cert_button_set_captive_login_window (CertButton* self,
                                      CaptiveLogin* value)
{
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (cert_button_get_captive_login_window (self) != value) {
#line 1083 "CertButton.c"
		CaptiveLogin* _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (self->priv->_captive_login_window);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		self->priv->_captive_login_window = _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY]);
#line 1093 "CertButton.c"
	}
}


static void
_cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                            gpointer self)
{
#line 85 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_button_on_tls_button_click ((CertButton*) self);
#line 1104 "CertButton.c"
}


static GObject *
cert_button_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CertButton * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	parent_class = G_OBJECT_CLASS (cert_button_parent_class);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	style_context = _tmp1_;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp2_ = style_context;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 83 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp3_ = style_context;
#line 83 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp3_, "titlebutton");
#line 85 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_object ((GtkToggleButton*) self, "toggled", (GCallback) _cert_button_on_tls_button_click_gtk_toggle_button_toggled, self, 0);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (style_context);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return obj;
#line 1147 "CertButton.c"
}


static void
cert_button_class_init (CertButtonClass * klass)
{
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_button_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_type_class_add_private (klass, sizeof (CertButtonPrivate));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cert_button_get_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cert_button_set_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->constructor = cert_button_constructor;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->finalize = cert_button_finalize;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_SECURITY_PROPERTY, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY] = g_param_spec_enum ("security", "security", "security", CERT_BUTTON_TYPE_SECURITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY] = g_param_spec_object ("captive-login-window", "captive-login-window", "captive-login-window", TYPE_CAPTIVE_LOGIN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1170 "CertButton.c"
}


static void
cert_button_instance_init (CertButton * self)
{
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self->priv = CERT_BUTTON_GET_PRIVATE (self);
#line 1179 "CertButton.c"
}


static void
cert_button_finalize (GObject * obj)
{
	CertButton * self;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 72 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (self->priv->_captive_login_window);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (cert_button_parent_class)->finalize (obj);
#line 1193 "CertButton.c"
}


GType
cert_button_get_type (void)
{
	static volatile gsize cert_button_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CertButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cert_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CertButton), 0, (GInstanceInitFunc) cert_button_instance_init, NULL };
		GType cert_button_type_id;
		cert_button_type_id = g_type_register_static (gtk_toggle_button_get_type (), "CertButton", &g_define_type_info, 0);
		g_once_init_leave (&cert_button_type_id__volatile, cert_button_type_id);
	}
	return cert_button_type_id__volatile;
}


static void
_vala_cert_button_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_value_set_enum (value, cert_button_get_security (self));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_value_set_object (value, cert_button_get_captive_login_window (self));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1233 "CertButton.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1239 "CertButton.c"
	}
}


static void
_vala_cert_button_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		cert_button_set_security (self, g_value_get_enum (value));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		cert_button_set_captive_login_window (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1266 "CertButton.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1272 "CertButton.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



