/* TabbedWebView.c generated by valac 0.39.7, the Vala compiler
 * generated from TabbedWebView.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (http://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <webkit2/webkit2.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>


#define TYPE_TABBED_WEB_VIEW (tabbed_web_view_get_type ())
#define TABBED_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TABBED_WEB_VIEW, TabbedWebView))
#define TABBED_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TABBED_WEB_VIEW, TabbedWebViewClass))
#define IS_TABBED_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TABBED_WEB_VIEW))
#define IS_TABBED_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TABBED_WEB_VIEW))
#define TABBED_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TABBED_WEB_VIEW, TabbedWebViewClass))

typedef struct _TabbedWebView TabbedWebView;
typedef struct _TabbedWebViewClass TabbedWebViewClass;
typedef struct _TabbedWebViewPrivate TabbedWebViewPrivate;

#define CERT_BUTTON_TYPE_SECURITY (cert_button_security_get_type ())
enum  {
	TABBED_WEB_VIEW_0_PROPERTY,
	TABBED_WEB_VIEW_SECURITY_PROPERTY,
	TABBED_WEB_VIEW_NUM_PROPERTIES
};
static GParamSpec* tabbed_web_view_properties[TABBED_WEB_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TabbedWebView {
	GraniteWidgetsTab parent_instance;
	TabbedWebViewPrivate * priv;
	WebKitWebView* web_view;
};

struct _TabbedWebViewClass {
	GraniteWidgetsTabClass parent_class;
};

typedef enum  {
	CERT_BUTTON_SECURITY_NONE,
	CERT_BUTTON_SECURITY_SECURE,
	CERT_BUTTON_SECURITY_LOADING,
	CERT_BUTTON_SECURITY_MIXED_CONTENT
} CertButtonSecurity;

struct _TabbedWebViewPrivate {
	CertButtonSecurity _security;
};


static gpointer tabbed_web_view_parent_class = NULL;

GType tabbed_web_view_get_type (void) G_GNUC_CONST;
GType cert_button_security_get_type (void) G_GNUC_CONST;
#define TABBED_WEB_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TABBED_WEB_VIEW, TabbedWebViewPrivate))
TabbedWebView* tabbed_web_view_new (const gchar* uri,
                                    gboolean load_cookies);
TabbedWebView* tabbed_web_view_construct (GType object_type,
                                          const gchar* uri,
                                          gboolean load_cookies);
static void tabbed_web_view_setup_web_view (TabbedWebView* self,
                                     gboolean load_cookies);
static void __lambda4_ (TabbedWebView* self);
static void tabbed_web_view_set_security (TabbedWebView* self,
                                   CertButtonSecurity value);
static void ___lambda4__webkit_web_view_insecure_content_detected (WebKitWebView* _sender,
                                                            WebKitInsecureContentEvent event,
                                                            gpointer self);
static void __lambda5_ (TabbedWebView* self,
                 GObject* view,
                 GParamSpec* param_spec);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda6_ (TabbedWebView* self,
                 WebKitWebView* view,
                 WebKitLoadEvent event);
static void tabbed_web_view_update_tls_info (TabbedWebView* self);
static void ___lambda6__webkit_web_view_load_changed (WebKitWebView* _sender,
                                               WebKitLoadEvent load_event,
                                               gpointer self);
CertButtonSecurity tabbed_web_view_get_security (TabbedWebView* self);
static void tabbed_web_view_finalize (GObject * obj);
static void _vala_tabbed_web_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_tabbed_web_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


static void
__lambda4_ (TabbedWebView* self)
{
#line 33 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	tabbed_web_view_set_security (self, CERT_BUTTON_SECURITY_MIXED_CONTENT);
#line 127 "TabbedWebView.c"
}


static void
___lambda4__webkit_web_view_insecure_content_detected (WebKitWebView* _sender,
                                                       WebKitInsecureContentEvent event,
                                                       gpointer self)
{
#line 32 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	__lambda4_ ((TabbedWebView*) self);
#line 138 "TabbedWebView.c"
}


static void
__lambda5_ (TabbedWebView* self,
            GObject* view,
            GParamSpec* param_spec)
{
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (view != NULL);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (param_spec != NULL);
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp0_ = self->web_view;
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp1_ = webkit_web_view_get_title (_tmp0_);
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	granite_widgets_tab_set_label ((GraniteWidgetsTab*) self, _tmp1_);
#line 159 "TabbedWebView.c"
}


static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	__lambda5_ ((TabbedWebView*) self, _sender, pspec);
#line 170 "TabbedWebView.c"
}


static void
__lambda6_ (TabbedWebView* self,
            WebKitWebView* view,
            WebKitLoadEvent event)
{
#line 40 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (view != NULL);
#line 41 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	switch (event) {
#line 41 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		case WEBKIT_LOAD_STARTED:
#line 185 "TabbedWebView.c"
		{
#line 43 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			tabbed_web_view_set_security (self, CERT_BUTTON_SECURITY_LOADING);
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			break;
#line 191 "TabbedWebView.c"
		}
#line 41 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		case WEBKIT_LOAD_COMMITTED:
#line 195 "TabbedWebView.c"
		{
#line 46 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			tabbed_web_view_update_tls_info (self);
#line 47 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			break;
#line 201 "TabbedWebView.c"
		}
		default:
#line 41 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		break;
#line 206 "TabbedWebView.c"
	}
}


static void
___lambda6__webkit_web_view_load_changed (WebKitWebView* _sender,
                                          WebKitLoadEvent load_event,
                                          gpointer self)
{
#line 40 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	__lambda6_ ((TabbedWebView*) self, _sender, load_event);
#line 218 "TabbedWebView.c"
}


TabbedWebView*
tabbed_web_view_construct (GType object_type,
                           const gchar* uri,
                           gboolean load_cookies)
{
	TabbedWebView * self = NULL;
	WebKitWebView* _tmp0_;
	WebKitWebView* _tmp1_;
	WebKitWebView* _tmp2_;
	WebKitWebView* _tmp3_;
	WebKitWebView* _tmp4_;
	WebKitWebView* _tmp5_;
#line 25 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 25 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	self = (TabbedWebView*) granite_widgets_tab_construct (object_type, "", NULL, NULL);
#line 26 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp0_ = (WebKitWebView*) webkit_web_view_new ();
#line 26 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_object_ref_sink (_tmp0_);
#line 26 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_g_object_unref0 (self->web_view);
#line 26 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	self->web_view = _tmp0_;
#line 28 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp1_ = self->web_view;
#line 28 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	granite_widgets_tab_set_page ((GraniteWidgetsTab*) self, (GtkWidget*) _tmp1_);
#line 30 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	tabbed_web_view_setup_web_view (self, load_cookies);
#line 32 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp2_ = self->web_view;
#line 32 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_signal_connect_object (_tmp2_, "insecure-content-detected", (GCallback) ___lambda4__webkit_web_view_insecure_content_detected, self, 0);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp3_ = self->web_view;
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::title", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 40 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp4_ = self->web_view;
#line 40 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_signal_connect_object (_tmp4_, "load-changed", (GCallback) ___lambda6__webkit_web_view_load_changed, self, 0);
#line 51 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp5_ = self->web_view;
#line 51 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	webkit_web_view_load_uri (_tmp5_, uri);
#line 25 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	return self;
#line 270 "TabbedWebView.c"
}


TabbedWebView*
tabbed_web_view_new (const gchar* uri,
                     gboolean load_cookies)
{
#line 25 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	return tabbed_web_view_construct (TYPE_TABBED_WEB_VIEW, uri, load_cookies);
#line 280 "TabbedWebView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	return self ? g_object_ref (self) : NULL;
#line 289 "TabbedWebView.c"
}


static void
tabbed_web_view_update_tls_info (TabbedWebView* self)
{
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0;
	gboolean is_secure = FALSE;
	WebKitWebView* _tmp0_;
	GTlsCertificate* _tmp1_ = NULL;
	GTlsCertificateFlags _tmp2_ = 0;
	gboolean _tmp3_;
	GTlsCertificate* _tmp4_;
	gboolean _tmp6_;
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp0_ = self->web_view;
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp3_ = webkit_web_view_get_tls_info (_tmp0_, &_tmp1_, &_tmp2_);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_g_object_unref0 (cert);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	cert = _tmp4_;
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	cert_flags = _tmp2_;
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	if (!_tmp3_) {
#line 61 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		is_secure = FALSE;
#line 323 "TabbedWebView.c"
	} else {
		GTlsCertificateFlags _tmp5_;
#line 65 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp5_ = cert_flags;
#line 65 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		is_secure = _tmp5_ == 0;
#line 330 "TabbedWebView.c"
	}
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp6_ = is_secure;
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	if (_tmp6_) {
#line 69 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		tabbed_web_view_set_security (self, CERT_BUTTON_SECURITY_SECURE);
#line 338 "TabbedWebView.c"
	} else {
#line 71 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		tabbed_web_view_set_security (self, CERT_BUTTON_SECURITY_NONE);
#line 342 "TabbedWebView.c"
	}
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_g_object_unref0 (cert);
#line 346 "TabbedWebView.c"
}


static void
tabbed_web_view_setup_web_view (TabbedWebView* self,
                                gboolean load_cookies)
{
#line 75 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	if (load_cookies) {
#line 358 "TabbedWebView.c"
		gchar* cookies_db_path = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		WebKitCookieManager* cookie_manager = NULL;
		WebKitWebView* _tmp3_;
		WebKitWebContext* _tmp4_;
		WebKitCookieManager* _tmp5_;
		WebKitCookieManager* _tmp6_;
		WebKitCookieManager* _tmp7_;
		WebKitCookieManager* _tmp8_;
		const gchar* _tmp9_;
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp0_ = g_get_user_config_dir ();
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "epiphany", "cookies.sqlite", NULL);
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		cookies_db_path = _tmp1_;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp2_ = cookies_db_path;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		if (!g_file_test (_tmp2_, G_FILE_TEST_IS_REGULAR)) {
#line 83 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			g_debug ("TabbedWebView.vala:83: No cookies store found, not saving the cookies." \
"..\n");
#line 84 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			_g_free0 (cookies_db_path);
#line 84 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
			return;
#line 387 "TabbedWebView.c"
		}
#line 87 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp3_ = self->web_view;
#line 87 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp4_ = webkit_web_view_get_context (_tmp3_);
#line 87 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp5_ = webkit_web_context_get_cookie_manager (_tmp4_);
#line 87 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 87 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		cookie_manager = _tmp6_;
#line 89 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp7_ = cookie_manager;
#line 89 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		webkit_cookie_manager_set_accept_policy (_tmp7_, WEBKIT_COOKIE_POLICY_ACCEPT_ALWAYS);
#line 90 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp8_ = cookie_manager;
#line 90 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_tmp9_ = cookies_db_path;
#line 90 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		webkit_cookie_manager_set_persistent_storage (_tmp8_, _tmp9_, WEBKIT_COOKIE_PERSISTENT_STORAGE_SQLITE);
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_g_object_unref0 (cookie_manager);
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		_g_free0 (cookies_db_path);
#line 413 "TabbedWebView.c"
	}
}


CertButtonSecurity
tabbed_web_view_get_security (TabbedWebView* self)
{
	CertButtonSecurity result;
	CertButtonSecurity _tmp0_;
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_tmp0_ = self->priv->_security;
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	result = _tmp0_;
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	return result;
#line 431 "TabbedWebView.c"
}


static void
tabbed_web_view_set_security (TabbedWebView* self,
                              CertButtonSecurity value)
{
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	if (tabbed_web_view_get_security (self) != value) {
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		self->priv->_security = value;
#line 23 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		g_object_notify_by_pspec ((GObject *) self, tabbed_web_view_properties[TABBED_WEB_VIEW_SECURITY_PROPERTY]);
#line 447 "TabbedWebView.c"
	}
}


static void
tabbed_web_view_class_init (TabbedWebViewClass * klass)
{
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	tabbed_web_view_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_type_class_add_private (klass, sizeof (TabbedWebViewPrivate));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tabbed_web_view_get_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tabbed_web_view_set_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	G_OBJECT_CLASS (klass)->finalize = tabbed_web_view_finalize;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TABBED_WEB_VIEW_SECURITY_PROPERTY, tabbed_web_view_properties[TABBED_WEB_VIEW_SECURITY_PROPERTY] = g_param_spec_enum ("security", "security", "security", CERT_BUTTON_TYPE_SECURITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 467 "TabbedWebView.c"
}


static void
tabbed_web_view_instance_init (TabbedWebView * self)
{
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	self->priv = TABBED_WEB_VIEW_GET_PRIVATE (self);
#line 476 "TabbedWebView.c"
}


static void
tabbed_web_view_finalize (GObject * obj)
{
	TabbedWebView * self;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TABBED_WEB_VIEW, TabbedWebView);
#line 22 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	_g_object_unref0 (self->web_view);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	G_OBJECT_CLASS (tabbed_web_view_parent_class)->finalize (obj);
#line 490 "TabbedWebView.c"
}


GType
tabbed_web_view_get_type (void)
{
	static volatile gsize tabbed_web_view_type_id__volatile = 0;
	if (g_once_init_enter (&tabbed_web_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TabbedWebViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tabbed_web_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TabbedWebView), 0, (GInstanceInitFunc) tabbed_web_view_instance_init, NULL };
		GType tabbed_web_view_type_id;
		tabbed_web_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_TAB, "TabbedWebView", &g_define_type_info, 0);
		g_once_init_leave (&tabbed_web_view_type_id__volatile, tabbed_web_view_type_id);
	}
	return tabbed_web_view_type_id__volatile;
}


static void
_vala_tabbed_web_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	TabbedWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TABBED_WEB_VIEW, TabbedWebView);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		case TABBED_WEB_VIEW_SECURITY_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		g_value_set_enum (value, tabbed_web_view_get_security (self));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		break;
#line 524 "TabbedWebView.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		break;
#line 530 "TabbedWebView.c"
	}
}


static void
_vala_tabbed_web_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	TabbedWebView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TABBED_WEB_VIEW, TabbedWebView);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		case TABBED_WEB_VIEW_SECURITY_PROPERTY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		tabbed_web_view_set_security (self, g_value_get_enum (value));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		break;
#line 551 "TabbedWebView.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/TabbedWebView.vala"
		break;
#line 557 "TabbedWebView.c"
	}
}



